# -*- coding: utf-8 -*-
"""mapping.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1S_JB7IBosfmcOjHb7rH6CeciXrB47OoA

# AUTO MAPPING

**Шаг 1:** Получение данных через API,
Инициализация API клиентов:
Настроить API клиенты для Ozon и Wildberries с использованием предоставленных токенов.
Добавить поддержку для Yandex Market, когда будет предоставлен токен.
Получение категорий и атрибутов:
Создать методы для обращения к API и получения списков категорий и атрибутов.
Сохранить полученные данные в локальные JSON файлы для дальнейшего анализа и использования.

**Шаг 2:** Парсинг данных
Парсинг данных:
Разобрать полученные данные из JSON файлов и создать структуры данных (например, словари) для быстрого доступа к категориям и атрибутам.
Подготовить данные для обучения и тестирования моделей машинного обучения.

**Шаг 3:** Интеграция с GPT
Настройка взаимодействия с GPT:
Написать функции для отправки запросов к GPT для обработки и преобразования данных.
Протестировать преобразование категорий и атрибутов на небольших выборках данных для проверки точности.

**Шаг 4:** Подборка промта и тестирование точности.
Разработка и тестирование промтов:
Разработать и тестировать различные промты для получения наилучших результатов преобразования данных.
Оценить точность маппинга категорий и атрибутов, используя реальные данные.

**Шаг 5:** Подключение API GPT (если необходимо)
Интеграция API GPT:
Если результаты удовлетворительны, подключить API GPT для автоматизированной обработки больших объемов данных.
Убедиться в правильности и устойчивости решения при работе с большими наборами данных.

# OZON

## 1) тестирование получения списка категорий

**В этом разделе мы хотим научиться парсить граф списка категорий товаров и по нему долезать до листьев (в буквальном смыле листьев графа - a.k.a. категории последнего слоя)**
"""

import requests
import json
import openai
import pandas as pd
import csv
from difflib import get_close_matches

# Let's start by loading the contents of the uploaded files to understand their structure and content.

class OzonAPI:
    def __init__(self, client_id, api_key):
        self.client_id = client_id
        self.api_key = api_key

    def _post(self, url, data):
        headers = {
            'Client-Id': self.client_id,
            'Api-Key': self.api_key,
            'Content-Type': 'application/json'
        }
        response = requests.post(url, headers=headers, json=data)
        try:
            response_json = response.json()
            return response_json
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
            return None

    def get_categories(self, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/tree'
        data = {'language': language}
        return self._post(url, data)

# Инициализация клиента API
ozon_api = OzonAPI('1955012', '376ff8a6-f8b7-4c31-a8aa-7aa374000d9e')

# Получение дерева категорий
categories = ozon_api.get_categories()

# Запись данных о категориях в файл
with open('ozon_categories.json', 'w', encoding='utf-8') as f:
    json.dump(categories, f, ensure_ascii=False, indent=4)

print("Данные о категориях записаны в ozon_categories.json")

"""## Начало вывода:

**Что получается на выходе** (только супер маленькая часть вывода - там порядка 100.000 строчек)

```
{
    "result": [
        {
            "description_category_id": 92130764,
            "category_name": "Музыкальные инструменты",
            "disabled": false,
            "children": [
                {
                    "description_category_id": 18262714,
                    "category_name": "Ударные инструменты и перкуссия",
                    "disabled": false,
                    "children": [
                        {
                            "type_name": "Ударная установка",
                            "type_id": 96836,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Перкуссия",
                            "type_id": 96830,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Концертный барабан",
                            "type_id": 96840,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Ударная тарелка",
                            "type_id": 96837,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Ксилофон",
                            "type_id": 96832,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Электронный барабан",
                            "type_id": 96835,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Народный ударный инструмент",
                            "type_id": 96831,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Гонг",
                            "type_id": 96834,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Барабан для установки",
                            "type_id": 96841,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Маршевый барабан",
                            "type_id": 96839,
                            "disabled": false,
                            "children": []
                        },
                        {
                            "type_name": "Музыкальный колокольчик",
                            "type_id": 96833,
                            "disabled": false,
                            "children": []
                        }
                    ]
                },
                {
                    "description_category_id": 18262713,
                    "category_name": "Духовые инструменты",
                    "disabled": false,
                    "children": [
                        {
                            "type_name": "Народный духовой инструмент",
                            "type_id": 96818,
                            "disabled": false,
                            "children": []
                        },
  ```

## Тестирование получения атрибутов

Чотим для каждой категории научитья получать атрибуты. В **озоне** с ними вместе идут и пояснения к тому, какими эти атрибуты должны быть. Сделаем это  на каком-то кусочке данных
"""

categories_test = {
    "result": [
        {
            "description_category_id": 17027492,
            "category_name": "Канцелярские товары",
            "disabled": False,
            "children": [
                {
                    "description_category_id": 200001634,
                    "category_name": "Канцелярские мелочи",
                    "disabled": False,
                    "children": [
                        {
                            "type_name": "Булавки канцелярские",
                            "type_id": 970808621,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "Скрепки",
                            "type_id": 93316,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "Скобы для степлера",
                            "type_id": 93315,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "Резинка канцелярская",
                            "type_id": 93313,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "Лезвия канцелярские",
                            "type_id": 93297,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "Кнопки канцелярские",
                            "type_id": 93294,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "Зажим для бумаги",
                            "type_id": 93290,
                            "disabled": False,
                            "children": []
                        },
                        {
                            "type_name": "3D-принтер",
                            "type_id": 91512,
                            "disabled": False,
                            "children": []
                        }
                    ]
                }
            ]
        }
    ]
}

class OzonAPI:
    def __init__(self, client_id, api_key):
        self.client_id = client_id
        self.api_key = api_key

    def _post(self, url, data):
        headers = {
            'Client-Id': self.client_id,
            'Api-Key': self.api_key,
            'Content-Type': 'application/json'
        }
        response = requests.post(url, headers=headers, json=data)
        try:
            response_json = response.json()
            return response_json
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
            return None

    def get_categories(self, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/tree'
        data = {'language': language}
        return self._post(url, data)

    def get_attributes(self, description_category_id, type_id, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/attribute'
        data = {
            'description_category_id': description_category_id,
            'type_id': type_id,
            'language': language
        }
        return self._post(url, data)

# Инициализация клиента API
ozon_api = OzonAPI('1955012', '376ff8a6-f8b7-4c31-a8aa-7aa374000d9e')

# Дерево категорий (из ранее сохраненного файла или непосредственно из API)
categories = categories_test

# Функция для получения атрибутов по категориям и типам товаров
def get_attributes_for_categories(categories):
    attributes_data = []
    for category in categories['result']:
        for subcategory in category['children']:
            category_id = subcategory['description_category_id']
            for child in subcategory['children']:
                type_id = child.get('type_id')
                if type_id:
                    attributes = ozon_api.get_attributes(category_id, type_id)
                    attributes_data.append({
                        'category_id': category_id,
                        'type_id': type_id,
                        'attributes': attributes
                    })
    return attributes_data

# Получение атрибутов для подкатегорий и типов товаров
attributes_data = get_attributes_for_categories(categories)

# Запись данных о категориях и атрибутах в файл
with open('ozon_categories_with_attributes.json', 'w', encoding='utf-8') as f:
    json.dump(attributes_data, f, ensure_ascii=False, indent=4)

print("Данные о категориях и атрибутах записаны в ozon_categories_with_attributes.json")

"""```
[
    {
        "category_id": 200001634,
        "type_id": 970808621,
        "attributes": {
            "result": [
                {
                    "id": 85,
                    "attribute_complex_id": 0,
                    "name": "Бренд",
                    "description": "Укажите наименование бренда, под которым произведен товар. Если товар не имеет бренда, используйте значение \"Нет бренда\".",
                    "type": "String",
                    "is_collection": false,
                    "is_required": true,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 28732849,
                    "category_dependent": true
                },
                {
                    "id": 8229,
                    "attribute_complex_id": 0,
                    "name": "Тип",
                    "description": "Выберите наиболее подходящий тип товара. По типам товары распределяются по категориям на сайте Ozon. Если тип указан неправильно, товар попадет в неверную категорию. Чтобы правильно указать тип, найдите на сайте Ozon товары, похожие на ваш, и посмотрите, какой тип у них указан.",
                    "type": "String",
                    "is_collection": false,
                    "is_required": true,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 1960,
                    "category_dependent": true
                },
                {
                    "id": 9048,
                    "attribute_complex_id": 0,
                    "name": "Название модели (для объединения в одну карточку)",
                    "description": "Укажите название модели товара. Не указывайте в этом поле тип и бренд.",
                    "type": "String",
                    "is_collection": false,
                    "is_required": true,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 0,
                    "category_dependent": false
                },
                {
                    "id": 4080,
                    "attribute_complex_id": 0,
                    "name": "3D-изображение",
                    "description": "Укажите ссылки на фото, через запятую, которые показывает товар под разными равными углами. В серии фото важно соблюдать последовательность, чтобы ракурс каждого следующего фото отличался от предыдущего на равный угол. Из этих фотографий на сайте автоматически сформируется 3D-модель товара. Минимальное рекомендованное количество - 15 штук.",
                    "type": "URL",
                    "is_collection": true,
                    "is_required": false,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 0,
                    "category_dependent": false
                },
                {
                    "id": 4180,
                    "attribute_complex_id": 0,
                    "name": "Название",
                    "description": "Название пишется по принципу:\nТип + Бренд + Модель (серия + пояснение) + Артикул производителя + , (запятая) + Атрибут\nНазвание не пишется большими буквами (не используем caps lock).\nПеред атрибутом ставится запятая. Если атрибутов несколько, они так же разделяются запятыми.\nЕсли какой-то составной части названия нет - пропускаем её.\nАтрибутом может быть: цвет, вес, объём, количество штук в упаковке и т.д.\nЦвет пишется с маленькой буквы, в мужском роде, единственном числе.\nСлово цвет в названии не пишем.\nТочка в конце не ставится.\nНикаких знаков препинания, кроме запятой, не используем.\nКавычки используем только для названий на русском языке.\nПримеры корректных названий:\nСмартфон Apple iPhone XS MT572RU/A, space black \nКеды Dr. Martens Киноклассика, бело-черные, размер 43\nСтиральный порошок Ariel Магия белого с мерной ложкой, 15 кг\nСоус Heinz Xtreme Tabasco суперострый, 10 мл\nИгрушка для животных Четыре лапы \"Бегающая мышка\" БММ, белый",
                    "type": "String",
                    "is_collection": false,
                    "is_required": false,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 0,
                    "category_dependent": false
                },
                {
                    "id": 4191,
                    "attribute_complex_id": 0,
                    "name": "Аннотация",
                    "description": "Описание товара, маркетинговый текст. Необходимо заполнять на русском языке.",
                    "type": "multiline",
                    "is_collection": false,
                    "is_required": false,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 0,
                    "category_dependent": false
                },
                {
                    "id": 4384,
                    "attribute_complex_id": 0,
                    "name": "Комплектация",
                    "description": "Перечислите, что входит в комплект вместе с товаром",
                    "type": "multiline",
                    "is_collection": false,
                    "is_required": false,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 0,
                    "category_dependent": false
                },
                {
                    "id": 4385,
                    "attribute_complex_id": 0,
                    "name": "Гарантийный срок",
                    "description": "Укажите гарантийный срок. Гарантийный срок – это период, в течение которого изготовитель гарантирует качество товара и обязуется принять данный товар у потребителя для проведения проверки качества (экспертизы) и выполнения предусмотренных законом требований.",
                    "type": "String",
                    "is_collection": false,
                    "is_required": false,
                    "is_aspect": false,
                    "max_value_count": 0,
                    "group_name": "",
                    "group_id": 0,
                    "dictionary_id": 0,
                    "category_dependent": false
                },
                {
                    "id": 4389,
                    "attribute_complex_id": 0,
                    "name": "Страна-изготовитель",
                    "description": "Выберите одно или несколько значений из списка. В xls-файле варианты заполняются через точку с запятой (;) без пробелов.",
                    "type": "String",
                    "is_collection": true,
                    "is_required": false,
                    "is_aspect": false,
```

Ну вот получили какую-то структуру, которая содержит атрибут. Осталось в удобоваримом виде сопоставить их с категорией

## Теперь построим таблицу соответствия категория -аттрибуты - описания аттрибутов
"""

class OzonAPI:
    def __init__(self, client_id, api_key):
        self.client_id = client_id
        self.api_key = api_key

    def _post(self, url, data):
        headers = {
            'Client-Id': self.client_id,
            'Api-Key': self.api_key,
            'Content-Type': 'application/json'
        }
        response = requests.post(url, headers=headers, json=data)
        try:
            response_json = response.json()
            return response_json
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
            return None

    def get_categories(self, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/tree'
        data = {'language': language}
        return self._post(url, data)

    def get_attributes(self, description_category_id, type_id, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/attribute'
        data = {
            'description_category_id': description_category_id,
            'type_id': type_id,
            'language': language
        }
        return self._post(url, data)

# Инициализация клиента API
ozon_api = OzonAPI('1955012', '376ff8a6-f8b7-4c31-a8aa-7aa374000d9e')

# Получение дерева категорий
categories = categories_test

# Функция для получения атрибутов по категориям и типам товаров
def get_attributes_for_categories(categories):
    attributes_data = []
    for category in categories['result']:
        for subcategory in category['children']:
            category_id = subcategory['description_category_id']
            for child in subcategory['children']:
                type_id = child.get('type_id')
                if type_id:
                    attributes = ozon_api.get_attributes(category_id, type_id)
                    if attributes and 'result' in attributes:
                        for attribute in attributes['result']:
                            attribute_data = {
                                'Категория': subcategory['category_name'],
                                'Тип': child['type_name'],
                                'Название атрибута': attribute.get('name'),
                                'Описание атрибута': attribute.get('description')
                            }
                            attributes_data.append(attribute_data)
    return attributes_data

# Получение атрибутов для подкатегорий и типов товаров
attributes_data = get_attributes_for_categories(categories)

# Конвертация в DataFrame и вывод в консоль
df = pd.DataFrame(attributes_data)
print(df.to_string(index=False))

# Для удобства можно сохранить таблицу в Excel
df.to_excel('ozon_attributes.xlsx', index=False)
print("Таблица атрибутов сохранена в ozon_attributes.xlsx")

"""вот получили удобоваримый вид. а именно табличку

# WILDBERRIES
"""

TOKEN = 'eyJhbGciOiJFUzI1NiIsImtpZCI6IjIwMjQwNTA2djEiLCJ0eXAiOiJKV1QifQ.eyJlbnQiOjEsImV4cCI6MTczMzQ1MzcwMywiaWQiOiJiNGUyYzBkMS1hYjRmLTQ5MjEtODk4Ni04MTZiODEwZmQyNmQiLCJpaWQiOjI2MjkxMzI3LCJvaWQiOjExMzIxNCwicyI6MTAsInNpZCI6Ijc4YmRmYmI1LTYyYTktNDFjMy04ZmY2LWRmZDQ2MzVkZTFkNCIsInQiOmZhbHNlLCJ1aWQiOjI2MjkxMzI3fQ.fOacJoGgkBb6gJuxWgf7vV8WKGcXJrFipFbNs4_bBMBnKtPIrZxhvnaYH2QviCHCENIhYBUmVugyjYI2BseVUQ'

"""##1) так же начали с парсинга категорий

Для получения списка категорий из Wildberries необходимо использовать метод GET /content/v2/object/all. Этот метод позволяет получить список категорий и подкатегорий товаров, используя текстовый фильтр (например, по имени категории). Для получения полного списка категорий можно задать параметр top большее, чем текущее количество категорий (например, top=8000).


"""


class WildberriesAPI:
    def __init__(self, api_key):
        self.api_key = api_key

    def _get(self, url, params=None):
        headers = {
            'Authorization': f'Bearer {self.api_key}',
            'Content-Type': 'application/json'
        }
        response = requests.get(url, headers=headers, params=params)
        try:
            response.raise_for_status()  # Проверка статуса HTTP
            response_json = response.json()
            return response_json
        except requests.exceptions.HTTPError as http_err:
            print(f"HTTP error occurred: {http_err}")
            print(f"Response content: {response.content}")
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
        return None

    def get_categories(self, top=8000):
        url = 'https://suppliers-api.wildberries.ru/content/v2/object/all'
        params = {
            'locale': 'ru'
        }
        return self._get(url, params=params)

    def save_data_to_file(self, data, filename):
        with open(filename, 'w', encoding='utf-8') as f:
            json.dump(data, f, ensure_ascii=False, indent=4)
        print(f"Данные записаны в {filename}")

# Инициализация клиента API
wildberries_api = WildberriesAPI(TOKEN)

# Получение списка категорий
categories_response = wildberries_api.get_categories()

# Проверка ответа и запись в файл
if categories_response:
    wildberries_api.save_data_to_file(categories_response, 'wildberries_categories.json')
else:
    print("Не удалось получить категории")

print("Готово")

"""```
{
    "data": [
        {
            "subjectID": 2560,
            "parentID": 479,
            "subjectName": "3D очки",
            "parentName": "Электроника"
        },
        {
            "subjectID": 1152,
            "parentID": 858,
            "subjectName": "3D-принтеры",
            "parentName": "Оргтехника"
        },
        {
            "subjectID": 1151,
            "parentID": 479,
            "subjectName": "3D-ручки",
            "parentName": "Электроника"
        },
        {
            "subjectID": 7771,
            "parentID": 760,
            "subjectName": "AKF системы",
            "parentName": "Автомобильные товары"
        },
        {
            "subjectID": 4034,
            "parentID": 6260,
            "subjectName": "AV-ресиверы",
            "parentName": "Телевизоры и аудиотехника"
        },
        {
            "subjectID": 1928,
            "parentID": 49,
            "subjectName": "BB-кремы",
            "parentName": "Красота"
        },
        {
            "subjectID": 4035,
            "parentID": 6260,
            "subjectName": "Blu-Ray проигрыватели",
            "parentName": "Телевизоры и аудиотехника"
        },
        {
            "subjectID": 1927,
            "parentID": 49,
            "subjectName": "CC-кремы",
            "parentName": "Красота"
        },
```

## опробовали на 1 предмете
"""


class WildberriesAPI:
    def __init__(self, api_key):
        self.api_key = api_key

    def _get(self, url, params=None):
        headers = {
            'Authorization': f'Bearer {self.api_key}',
            'Content-Type': 'application/json'
        }
        response = requests.get(url, headers=headers, params=params)
        try:
            response.raise_for_status()  # Проверка статуса HTTP
            response_json = response.json()
            return response_json
        except requests.exceptions.HTTPError as http_err:
            print(f"HTTP error occurred: {http_err}")
            print(f"Response content: {response.content}")
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
        return None

    def get_attributes(self, subject_id, locale='ru'):
        url = f'https://suppliers-api.wildberries.ru/content/v2/object/charcs/{subject_id}'
        params = {
            'locale': locale
        }
        return self._get(url, params=params)

# Инициализация клиента API
wildberries_api = WildberriesAPI(TOKEN)

# Получение характеристик для категории "3D-ручки" (subjectID: 1151)
subject_id = 1151
attributes_response = wildberries_api.get_attributes(subject_id)

# Проверка и вывод данных о характеристиках
if attributes_response:
    print(json.dumps(attributes_response, ensure_ascii=False, indent=4))
else:
    print("Не удалось получить характеристики для категории 3D-ручки")


TOKEN = 'eyJhbGciOiJFUzI1NiIsImtpZCI6IjIwMjQwNTA2djEiLCJ0eXAiOiJKV1QifQ.eyJlbnQiOjEsImV4cCI6MTczMzQ1MzcwMywiaWQiOiJiNGUyYzBkMS1hYjRmLTQ5MjEtODk4Ni04MTZiODEwZmQyNmQiLCJpaWQiOjI2MjkxMzI3LCJvaWQiOjExMzIxNCwicyI6MTAsInNpZCI6Ijc4YmRmYmI1LTYyYTktNDFjMy04ZmY2LWRmZDQ2MzVkZTFkNCIsInQiOmZhbHNlLCJ1aWQiOjI2MjkxMzI3fQ.fOacJoGgkBb6gJuxWgf7vV8WKGcXJrFipFbNs4_bBMBnKtPIrZxhvnaYH2QviCHCENIhYBUmVugyjYI2BseVUQ'

class WildberriesAPI:
    def __init__(self, api_key):
        self.api_key = api_key

    def _get(self, url, params=None):
        headers = {
            'Authorization': f'Bearer {self.api_key}',
            'Content-Type': 'application/json'
        }
        response = requests.get(url, headers=headers, params=params)
        try:
            response.raise_for_status()  # Проверка статуса HTTP
            response_json = response.json()
            return response_json
        except requests.exceptions.HTTPError as http_err:
            print(f"HTTP error occurred: {http_err}")
            print(f"Response content: {response.content}")
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
        return None

    def get_categories(self, top=80000):
        url = 'https://suppliers-api.wildberries.ru/content/v2/object/all'
        params = {
            'top': top,
            'locale': 'ru'
        }
        return self._get(url, params=params)

    def get_attributes(self, subject_id, locale='ru'):
        url = f'https://suppliers-api.wildberries.ru/content/v2/object/charcs/{subject_id}'
        params = {
            'locale': locale
        }
        return self._get(url, params=params)

    def save_data_to_file(self, data, filename):
        with open(filename, 'w', encoding='utf-8') as f:
            json.dump(data, f, ensure_ascii=False, indent=4)
        print(f"Данные записаны в {filename}")

# Инициализация клиента API
wildberries_api = WildberriesAPI(TOKEN)

# Получение списка категорий
categories_response = wildberries_api.get_categories()

# Проверка ответа и запись в файл
if categories_response:
    wildberries_api.save_data_to_file(categories_response, 'wildberries_categories.json')
    print("Данные о категориях записаны в wildberries_categories.json")
else:
    print("Не удалось получить категории")

# Обработка категорий и получение атрибутов
def get_attributes_for_categories(categories):
    attributes_data = []
    for category in categories['data']:
        subject_id = category['subjectID']
        subject_name = category['subjectName']
        attributes = wildberries_api.get_attributes(subject_id)
        if attributes and 'data' in attributes:
            for attribute in attributes['data']:
                attribute_data = {
                    'Категория': subject_name,
                    'Название атрибута': attribute.get('name'),
                    'Описание атрибута': attribute.get('description', '')
                }
                attributes_data.append(attribute_data)
    return attributes_data

# Получение атрибутов для категорий
attributes_data = get_attributes_for_categories(categories_response)

# Конвертация в DataFrame и вывод в консоль
df = pd.DataFrame(attributes_data)
print(df.to_string(index=False))

# Для удобства можно сохранить таблицу в Excel
df.to_excel('wildberries_attributes.xlsx', index=False)
print("Таблица атрибутов сохранена в wildberries_attributes.xlsx")

"""## 3) Теперь построим две таблицы аттрибутов с разных площадок для, напримен, 3D принтера

мы ноучились делать один и тот же пайплайн по получению соответствия категория <-> информация об её аттрибутах как для wb так и для ozon. теперь применим его чтобы получить информацию такую для одного товара и посмотреть на две таблицы одновременно

**OZON**
```
{
    "type_name": "3D-принтер",
    "type_id": 91512,
    "disabled": false,
    "children": []
},
```
**WB**
```
{
  "subjectID": 1152,
  "parentID": 858,
  "subjectName": "3D-принтеры",
  "parentName": "Оргтехника"
},
```

**OZON**
"""


class OzonAPI:
    def __init__(self, client_id, api_key):
        self.client_id = client_id
        self.api_key = api_key

    def _post(self, url, data):
        headers = {
            'Client-Id': self.client_id,
            'Api-Key': self.api_key,
            'Content-Type': 'application/json'
        }
        response = requests.post(url, headers=headers, json=data)
        try:
            response_json = response.json()
            return response_json
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
            return None

    def get_attributes(self, description_category_id, type_id, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/attribute'
        data = {
            'description_category_id': description_category_id,
            'type_id': type_id,
            'language': language
        }
        return self._post(url, data)

# Инициализация клиента API
ozon_api = OzonAPI('1955012', '376ff8a6-f8b7-4c31-a8aa-7aa374000d9e')

# Чтение JSON с категориями из файла
with open('ozon_categories.json', 'r', encoding='utf-8') as file:
    categories = json.load(file)

# Поиск категории "3D-принтер" и получение атрибутов
def get_attributes_for_3d_printer(categories):
    for category in categories['result']:
        for subcategory in category['children']:
            for child in subcategory['children']:
                if child['type_name'] == "3D-принтер":
                    description_category_id = subcategory['description_category_id']
                    type_id = child['type_id']
                    attributes_response = ozon_api.get_attributes(description_category_id, type_id)
                    if attributes_response and 'result' in attributes_response:
                        return attributes_response['result']
    return None

# Получение атрибутов для категории "3D-принтер"
ozon_attributes = get_attributes_for_3d_printer(categories)

# Проверка и вывод данных о характеристиках
if ozon_attributes:
    attributes_data = []
    for attribute in ozon_attributes:
        attributes_data.append({
            'Название атрибута': attribute.get('name'),
            'Описание атрибута': attribute.get('description', '')
        })
    ozon_df = pd.DataFrame(attributes_data)
    print("OZON Атрибуты для категории '3D-принтер':")
    print(ozon_df.to_string(index=False))
else:
    print("Не удалось получить атрибуты для категории 3D-принтер (OZON)")

# Сохранение таблицы в Excel
ozon_df.to_excel('ozon_attributes_3d_printer.xlsx', index=False)
print("Таблица атрибутов сохранена в ozon_attributes_3d_printer.xlsx")

"""**WB**"""

class WildberriesAPI:
    def __init__(self, api_key):
        self.api_key = api_key

    def _get(self, url, params=None):
        headers = {
            'Authorization': f'Bearer {self.api_key}',
            'Content-Type': 'application/json'
        }
        response = requests.get(url, headers=headers, params=params)
        try:
            response.raise_for_status()  # Проверка статуса HTTP
            response_json = response.json()
            return response_json
        except requests.exceptions.HTTPError as http_err:
            print(f"HTTP error occurred: {http_err}")
            print(f"Response content: {response.content}")
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
        return None

    def get_attributes(self, subject_id, locale='ru'):
        url = f'https://suppliers-api.wildberries.ru/content/v2/object/charcs/{subject_id}'
        params = {
            'locale': locale
        }
        return self._get(url, params=params)

# Инициализация клиента API
wildberries_api = WildberriesAPI(TOKEN)

# Получение характеристик для категории "3D-принтеры" (subjectID: 1152)
subject_id = 1152
wb_attributes_response = wildberries_api.get_attributes(subject_id)

# Проверка и вывод данных о характеристиках
if wb_attributes_response:
    wb_attributes = []
    for attribute in wb_attributes_response['data']:
        wb_attributes.append({
            'Название атрибута': attribute.get('name'),
            'Описание атрибута': attribute.get('description', '')
        })
    wb_df = pd.DataFrame(wb_attributes)
    print("Wildberries Атрибуты для категории '3D-принтеры':")
    print(wb_df.to_string(index=False))
else:
    print("Не удалось получить атрибуты для категории 3D-принтеры (Wildberries)")

"""вот смогли получить по вручную найденному товару в наших структурах (структура в смысле древовидое отображение категорий) информацию о аттрибутах для данной категории. теперь хочется сделать универсальный пайплайн который просто по признаковому описанию выдаст два блока информации про аттрибуты.

Что мы хотим дальше? На этом этапе мы хотим написать регулярное выражение - промт, которое вкулючает в себя описание как должны выглядеть аттрибуты на каждом маркетплейсе (уже умеем получать такие таблицы ) , названия из какого в какой маркетплейс пеерделать и наконец само описание которое нужно переделать. так же собрать все методы и классы вместе.

**WB -> OZON**

# создадим пример описания принтера на WB
"""

data = [
    {
        "Название": "super printer",
        "Категория": "3D-принтеры",
        "Вес, г": "4500",
        "Цвет": "Черный",
        "Описание товара": "3D-принтер с технологией печати FDM, автоматическим калиброванием и ЖК-дисплеем.",
        "Слот для карты памяти": "SD, MicroSD",
        "Модель": "XYZprinting da Vinci Jr. 1.0",
        "Гарантийный срок": "12 месяцев",
        "Интерфейс подключения": "USB, Wi-Fi",
        "Технология печати": "FDM",
        "Рабочая температура экструдера": "180-230°C",
        "Количество головок": "1",
        "Доп. опции 3D принтера": "Автоматическое калибрование, ЖК-дисплей",
        "Материал печати": "PLA, ABS",
        "Вес с упаковкой (кг)": "5",
        "Вес без упаковки (кг)": "4.5",
        "Высота предмета": "380 мм",
        "Глубина предмета": "430 мм",
        "Ширина предмета": "480 мм",
        "Область печати (см)": "15x15x15",
        "Печатный слой толщина": "0.1-0.4 мм",
        "Длина кабеля": "1.5 м",
        "Комплектация": "Принтер, кабель питания, инструкция, катушка PLA",
        "Страна производства": "Китай",
        "SKU": "XYZ1234",
        "Номер декларации соответствия": "RU1234567890",
        "Номер сертификата соответствия": "RU0987654321",
        "Дата регистрации сертификата/декларации": "01.01.2023",
        "Дата окончания действия сертификата/декларации": "01.01.2024",
        "Ставка НДС": "20%",
        "ИКПУ": "12345678",
        "Максимальная температура стола": "100°C",
        "Код упаковки": "05012345678900",
        "Партномер": "12345"
    }
]

# Запись данных в CSV файл
csv_file = 'input.csv'
with open(csv_file, 'w', newline='', encoding='utf-8') as f:
    writer = csv.DictWriter(f, fieldnames=data[0].keys())
    writer.writeheader()
    writer.writerows(data)

print(f"CSV файл '{csv_file}' создан с данными о 3D-принтере.")

"""| Название атрибута                      | Значение                                           |
|----------------------------------------|----------------------------------------------------|
| Слот для карты памяти                  | SD, MicroSD                                        |
| Модель                                 | XYZprinting da Vinci Jr. 1.0                       |
| Гарантийный срок                       | 12 месяцев                                         |
| Интерфейс подключения                  | USB, Wi-Fi                                         |
| Технология печати                      | FDM                                                |
| Рабочая температура экструдера         | 180-230°C                                          |
| Количество головок                     | 1                                                  |
| Доп. опции 3D принтера                 | Автоматическое калибрование, ЖК-дисплей            |
| Материал печати                        | PLA, ABS                                           |
| Вес с упаковкой (кг)                   | 5                                                  |
| Вес без упаковки (кг)                  | 4.5                                                |
| Высота предмета                        | 380 мм                                             |
| Глубина предмета                       | 430 мм                                             |
| Ширина предмета                        | 480 мм                                             |
| Область печати (см)                    | 15x15x15                                           |
| Печатный слой толщина                  | 0.1-0.4 мм                                         |
| Длина кабеля                           | 1.5 м                                              |
| Комплектация                           | Принтер, кабель питания, инструкция, катушка PLA   |
| Страна производства                    | Китай                                              |
| SKU                                    | XYZ1234                                            |
| Номер декларации соответствия          | RU1234567890                                       |
| Номер сертификата соответствия         | RU0987654321                                       |
| Дата регистрации сертификата/декларации| 01.01.2023                                         |
| Дата окончания действия сертификата/декларации | 01.01.2024                                      |
| Ставка НДС                             | 20%                                                |
| ИКПУ                                   | 12345678                                           |
| Максимальная температура стола         | 100°C                                              |
| Код упаковки                           | 05012345678900                                     |
| Партномер                              | 12345                                              |

# Все этапы технологии протестировали. теперь соберём их вместе

# первая итерация
"""

class MarketplaceTransformer:
    def load_csv(self, filepath):
        return pd.read_csv(filepath, encoding='utf-8')

    def load_json(self, filepath):
        with open(filepath, 'r', encoding='utf-8') as file:
            return json.load(file)

    def find_best_match(self, categories, target_category_name, key_name):
        category_names = [category[key_name] for category in categories]
        best_match = get_close_matches(target_category_name, category_names, n=1, cutoff=0.6)
        if best_match:
            return next(category for category in categories if category[key_name] == best_match[0])
        return None

    def extract_categories_data(self, categories):
        categories_data = []
        def recursive_extract(categories_list):
            for category in categories_list:
                if 'children' in category and category['children']:
                    recursive_extract(category['children'])
                else:
                    categories_data.append(category)
        recursive_extract(categories['result'])
        return categories_data

    def transform(self, input_csv):
        data = self.load_csv(input_csv)

        # Предполагается, что все товары в CSV файле относятся к одной категории
        source_category_name = data['Категория'].iloc[0]

        # Загрузка категорий Ozon
        categories = self.load_json('ozon_categories.json')
        categories_data = self.extract_categories_data(categories)

        target_category = self.find_best_match(categories_data, source_category_name, 'type_name')
        if not target_category:
            raise ValueError(f"Категория '{source_category_name}' не найдена в целевом маркетплейсе.")

        print("Найденная категория для Ozon:")
        print(json.dumps(target_category, ensure_ascii=False, indent=4))

# Инициализация и выполнение трансформации
transformer = MarketplaceTransformer()
transformer.transform('input.csv')

"""# вторая итерация. (WB->OZON)"""


class WildberriesAPI:
    def __init__(self, api_key):
        self.api_key = api_key

    def _get(self, url, params=None):
        headers = {
            'Authorization': f'Bearer {self.api_key}',
            'Content-Type': 'application/json'
        }
        response = requests.get(url, headers=headers, params=params)
        try:
            response.raise_for_status()  # Проверка статуса HTTP
            response_json = response.json()
            return response_json
        except requests.exceptions.HTTPError as http_err:
            print(f"HTTP error occurred: {http_err}")
            print(f"Response content: {response.content}")
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
        return None

    def get_categories(self, top=80000):
        url = 'https://suppliers-api.wildberries.ru/content/v2/object/all'
        params = {
            'top': top,
            'locale': 'ru'
        }
        return self._get(url, params=params)

    def get_attributes(self, subject_id, locale='ru'):
        url = f'https://suppliers-api.wildberries.ru/content/v2/object/charcs/{subject_id}'
        params = {
            'locale': locale
        }
        return self._get(url, params=params)

    def save_data_to_file(self, data, filename):
        with open(filename, 'w', encoding='utf-8') as f:
            json.dump(data, f, ensure_ascii=False, indent=4)
        print(f"Данные записаны в {filename}")

class OzonAPI:
    def __init__(self, client_id, api_key):
        self.client_id = client_id
        self.api_key = api_key

    def _post(self, url, data):
        headers = {
            'Client-Id': self.client_id,
            'Api-Key': self.api_key,
            'Content-Type': 'application/json'
        }
        response = requests.post(url, headers=headers, json=data)
        try:
            response_json = response.json()
            return response_json
        except json.JSONDecodeError:
            print("Ошибка декодирования JSON. Ответ от сервера:")
            print(response.text)
            return None

    def get_attributes(self, description_category_id, type_id, language='DEFAULT'):
        url = 'https://api-seller.ozon.ru/v1/description-category/attribute'
        data = {
            'description_category_id': description_category_id,
            'type_id': type_id,
            'language': language
        }
        return self._post(url, data)


class MarketplaceTransformer:
    def __init__(self, key1, key2):
        self.ozon_api = OzonAPI(key1, key2)

    def load_csv(self, filepath):
        return pd.read_csv(filepath, encoding='utf-8')

    def load_json(self, filepath):
        with open(filepath, 'r', encoding='utf-8') as file:
            return json.load(file)

    def find_best_match(self, categories, target_category_name, key_name):
        category_names = [category[key_name] for category in categories]
        best_match = get_close_matches(target_category_name, category_names, n=1, cutoff=0.6)
        if best_match:
            return next(category for category in categories if category[key_name] == best_match[0])
        return None

    def extract_categories_data(self, categories):
        categories_data = []
        def recursive_extract(categories_list):
            for category in categories_list:
                if 'children' in category and category['children']:
                    recursive_extract(category['children'])
                else:
                    categories_data.append(category)
        recursive_extract(categories['result'])
        return categories_data

    def get_cat(self, input_csv):
        data = self.load_csv(input_csv)

        # Предполагается, что все товары в CSV файле относятся к одной категории
        source_category_name = data['Категория'].iloc[0]

        # Загрузка категорий Ozon
        categories = self.load_json('ozon_categories.json')
        categories_data = self.extract_categories_data(categories)

        target_category = self.find_best_match(categories_data, source_category_name, 'type_name')
        if not target_category:
            raise ValueError(f"Категория '{source_category_name}' не найдена в целевом маркетплейсе.")

        #print("Найденная категория для Ozon:")
        #print(json.dumps(target_category, ensure_ascii=False, indent=4))
        #print(target_category['type_name'])
        return target_category

    def get_attr(self, input_csv):
        target_category = self.get_cat(input_csv)
        cat_type_name = target_category['type_name']

        # Чтение JSON с категориями из файла
        categories = self.load_json('ozon_categories.json')

        # Поиск категории и получение атрибутов
        def get_attributes_for_3d_printer(categories):
            for category in categories['result']:
                for subcategory in category['children']:
                    for child in subcategory['children']:
                        if child['type_name'] == cat_type_name:
                            description_category_id = subcategory['description_category_id']
                            type_id = child['type_id']
                            attributes_response = self.ozon_api.get_attributes(description_category_id, type_id)
                            if attributes_response and 'result' in attributes_response:
                                return attributes_response['result']
            return None

        # Получение атрибутов для категории
        ozon_attributes = get_attributes_for_3d_printer(categories)

        # Проверка и вывод данных о характеристиках
        if ozon_attributes:
            attributes_data = []
            for attribute in ozon_attributes:
                attributes_data.append({
                    'Название атрибута': attribute.get('name'),
                    'Описание атрибута': attribute.get('description', '')
                })
            ozon_df = pd.DataFrame(attributes_data)
            #print("OZON Атрибуты для категории '3D-принтер':")
            #print(ozon_df.to_string(index=False))
            return ozon_df.to_string(index=False)
        else:
            print("Не удалось получить атрибуты для категории 3D-принтер (OZON)")

        # Сохранение таблицы в Excel
        ozon_df.to_excel('ozon_attributes_3d_printer.xlsx', index=False)
        print("Таблица атрибутов сохранена в ozon_attributes_3d_printer.xlsx")

    def generate_prompt(self, input_csv):
        table = self.get_attr(input_csv)

        if not table:
            print("Не удалось получить атрибуты для категории (OZON)")
            return

        data = self.load_csv(input_csv)
        product_info = data.to_dict(orient='records')[0]

        prompt = "Пожалуйста, преобразуйте данные о товарах, используя следующую таблицу атрибутов для Ozon:\n\n"
        prompt += "Если в исходном файле отсутствуют необходимые графы для заполнения описания продукта, оставьте их пустыми.\n"
        prompt += "Также обращайте пристальное внимание на единицы измерения в графах.\n\n"

        prompt += "\nТаблица атрибутов для Ozon:\n\n"
        prompt += table

        prompt += "\n\nОписание товара в исходной таблице:\n\n"

        for key, value in product_info.items():
            prompt += f"{key}: {value}\n"

        prompt += "\n\ответ выдай в виде md таблицы\n\n"

        print(prompt)
        return prompt

    def transform_wb_2_ozon(self, input_csv):
        self.generate_prompt(input_csv)

# Инициализация и выполнение трансформации
transformer = MarketplaceTransformer('1955012', '376ff8a6-f8b7-4c31-a8aa-7aa374000d9e')
transformer. transform_wb_2_ozon('input.csv')


def get_chatgpt_response(prompt, openai_api_key):
    openai.api_key = openai_api_key
    response = openai.Completion.create(
        engine="text-davinci-003",
        prompt=prompt,
        max_tokens=1500,
        n=1,
        stop=None,
        temperature=0.5,
    )

    return response.choices[0].text.strip()

"""Было -> стало

наглядно (wb -> ozon)

| Название атрибута                      | Значение                                           |
|----------------------------------------|----------------------------------------------------|
| Слот для карты памяти                  | SD, MicroSD                                        |
| Модель                                 | XYZprinting da Vinci Jr. 1.0                       |
| Гарантийный срок                       | 12 месяцев                                         |
| Интерфейс подключения                  | USB, Wi-Fi                                         |
| Технология печати                      | FDM                                                |
| Рабочая температура экструдера         | 180-230°C                                          |
| Количество головок                     | 1                                                  |
| Доп. опции 3D принтера                 | Автоматическое калибрование, ЖК-дисплей            |
| Материал печати                        | PLA, ABS                                           |
| Вес с упаковкой (кг)                   | 5                                                  |
| Вес без упаковки (кг)                  | 4.5                                                |
| Высота предмета                        | 380 мм                                             |
| Глубина предмета                       | 430 мм                                             |
| Ширина предмета                        | 480 мм                                             |
| Область печати (см)                    | 15x15x15                                           |
| Печатный слой толщина                  | 0.1-0.4 мм                                         |
| Длина кабеля                           | 1.5 м                                              |
| Комплектация                           | Принтер, кабель питания, инструкция, катушка PLA   |
| Страна производства                    | Китай                                              |
| SKU                                    | XYZ1234                                            |
| Номер декларации соответствия          | RU1234567890                                       |
| Номер сертификата соответствия         | RU0987654321                                       |
| Дата регистрации сертификата/декларации| 01.01.2023                                         |
| Дата окончания действия сертификата/декларации | 01.01.2024                                      |
| Ставка НДС                             | 20%                                                |
| ИКПУ                                   | 12345678                                           |
| Максимальная температура стола         | 100°C                                              |
| Код упаковки                           | 05012345678900                                     |
| Партномер                              | 12345                                              |

| Название атрибута                  | Описание атрибута                                                                                                  |
|------------------------------------|---------------------------------------------------------------------------------------------------------------------|
| Бренд                              | XYZprinting                                                                                                         |
| Тип                                | 3D-принтеры                                                                                                         |
| Название модели (для объединения в одну карточку) | da Vinci Jr. 1.0                                                                                                   |
| 3D-изображение                     |                                                                                                                     |
| Название                           | 3D-принтер XYZprinting da Vinci Jr. 1.0, черный                                                                     |
| Аннотация                          | 3D-принтер с технологией печати FDM, автоматическим калиброванием и ЖК-дисплеем.                                    |
| Партномер                          | 12345                                                                                                               |
| Размеры, мм                        | 480x430x380                                                                                                         |
| Вес товара, г                      | 4500                                                                                                                |
| Комплектация                       | Принтер, кабель питания, инструкция, катушка PLA                                                                    |
| Гарантийный срок                   | 12 месяцев                                                                                                          |
| Страна-изготовитель                | Китай                                                                                                               |
| Тип карты памяти                   | SD;MicroSD                                                                                                          |
| Интерфейсы                         | USB;Wi-Fi                                                                                                           |
| Диапазон рабочих температур, °С    | 180-230°C                                                                                                           |
| Дисплей                            | ЖК-дисплей                                                                                                          |
| Срок службы, лет                   |                                                                                                                     |
| Название файла PDF                 |                                                                                                                     |
| Документ PDF                       |                                                                                                                     |
| Код продавца                       | XYZ1234                                                                                                             |
| Технология 3D печати               | FDM                                                                                                                 |
| Цвет товара                        | Черный                                                                                                              |
| Основной материал корпуса          |                                                                                                                     |
| Регулировка температуры            |                                                                                                                     |
| Rich-контент JSON                  |                                                                                                                     |
| Количество заводских упаковок      |                                                                                                                     |
| Диаметр сопла, мм                  |                                                                                                                     |
| Диаметр пластика, мм               |                                                                                                                     |
| Регулировка скорости               |                                                                                                                     |
| Тип печати                         | FDM                                                                                                                 |
| Минимальная толщина слоя, мкм      |                                                                                                                     |
| Скорость печати (экструдера), мм/сек |                                                                                                                     |
| Область построения (ДxШxВ), см     | 15x15x15                                                                                                            |
| Озон.Видео: название               |                                                                                                                     |
| Озон.Видео: ссылка                 |                                                                                                                     |
| Озон.Видеообложка: ссылка          |                                                                                                                     |
| Планирую доставлять товар в нескольких упаковках |                                                                                                                     |
| ТН ВЭД коды ЕАЭС                   |                                                                                                                     |
| Озон.Видео: товары на видео        |                                                                                                                     |
| Ключевые слова                     | 3D-принтер; FDM; автоматическое калибрование; ЖК-дисплей                                                            |
| Название серии                     |                                                                                                                     |
| HS-код                             |                                                                                                                     |
| ИКПУ                               | 12345678                                                                                                            |
"""